/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
} from "ethers";
import {
  Contract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "@ethersproject/contracts";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";

interface IRepayWithCollateralInterface extends ethers.utils.Interface {
  functions: {
    "swapAndRepay(address,address,uint256,uint256,uint256,tuple,bool)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "swapAndRepay",
    values: [
      string,
      string,
      BigNumberish,
      BigNumberish,
      BigNumberish,
      {
        amount: BigNumberish;
        deadline: BigNumberish;
        v: BigNumberish;
        r: BytesLike;
        s: BytesLike;
      },
      boolean
    ]
  ): string;

  decodeFunctionResult(
    functionFragment: "swapAndRepay",
    data: BytesLike
  ): Result;

  events: {};
}

export class IRepayWithCollateral extends Contract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  on(event: EventFilter | string, listener: Listener): this;
  once(event: EventFilter | string, listener: Listener): this;
  addListener(eventName: EventFilter | string, listener: Listener): this;
  removeAllListeners(eventName: EventFilter | string): this;
  removeListener(eventName: any, listener: Listener): this;

  interface: IRepayWithCollateralInterface;

  functions: {
    swapAndRepay(
      collateralAsset: string,
      debtAsset: string,
      collateralAmount: BigNumberish,
      debtRepayAmount: BigNumberish,
      debtRateMode: BigNumberish,
      permitSignature: {
        amount: BigNumberish;
        deadline: BigNumberish;
        v: BigNumberish;
        r: BytesLike;
        s: BytesLike;
      },
      useEthPath: boolean,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "swapAndRepay(address,address,uint256,uint256,uint256,tuple,bool)"(
      collateralAsset: string,
      debtAsset: string,
      collateralAmount: BigNumberish,
      debtRepayAmount: BigNumberish,
      debtRateMode: BigNumberish,
      permitSignature: {
        amount: BigNumberish;
        deadline: BigNumberish;
        v: BigNumberish;
        r: BytesLike;
        s: BytesLike;
      },
      useEthPath: boolean,
      overrides?: Overrides
    ): Promise<ContractTransaction>;
  };

  swapAndRepay(
    collateralAsset: string,
    debtAsset: string,
    collateralAmount: BigNumberish,
    debtRepayAmount: BigNumberish,
    debtRateMode: BigNumberish,
    permitSignature: {
      amount: BigNumberish;
      deadline: BigNumberish;
      v: BigNumberish;
      r: BytesLike;
      s: BytesLike;
    },
    useEthPath: boolean,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "swapAndRepay(address,address,uint256,uint256,uint256,tuple,bool)"(
    collateralAsset: string,
    debtAsset: string,
    collateralAmount: BigNumberish,
    debtRepayAmount: BigNumberish,
    debtRateMode: BigNumberish,
    permitSignature: {
      amount: BigNumberish;
      deadline: BigNumberish;
      v: BigNumberish;
      r: BytesLike;
      s: BytesLike;
    },
    useEthPath: boolean,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  callStatic: {
    swapAndRepay(
      collateralAsset: string,
      debtAsset: string,
      collateralAmount: BigNumberish,
      debtRepayAmount: BigNumberish,
      debtRateMode: BigNumberish,
      permitSignature: {
        amount: BigNumberish;
        deadline: BigNumberish;
        v: BigNumberish;
        r: BytesLike;
        s: BytesLike;
      },
      useEthPath: boolean,
      overrides?: CallOverrides
    ): Promise<void>;

    "swapAndRepay(address,address,uint256,uint256,uint256,tuple,bool)"(
      collateralAsset: string,
      debtAsset: string,
      collateralAmount: BigNumberish,
      debtRepayAmount: BigNumberish,
      debtRateMode: BigNumberish,
      permitSignature: {
        amount: BigNumberish;
        deadline: BigNumberish;
        v: BigNumberish;
        r: BytesLike;
        s: BytesLike;
      },
      useEthPath: boolean,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {};

  estimateGas: {
    swapAndRepay(
      collateralAsset: string,
      debtAsset: string,
      collateralAmount: BigNumberish,
      debtRepayAmount: BigNumberish,
      debtRateMode: BigNumberish,
      permitSignature: {
        amount: BigNumberish;
        deadline: BigNumberish;
        v: BigNumberish;
        r: BytesLike;
        s: BytesLike;
      },
      useEthPath: boolean,
      overrides?: Overrides
    ): Promise<BigNumber>;

    "swapAndRepay(address,address,uint256,uint256,uint256,tuple,bool)"(
      collateralAsset: string,
      debtAsset: string,
      collateralAmount: BigNumberish,
      debtRepayAmount: BigNumberish,
      debtRateMode: BigNumberish,
      permitSignature: {
        amount: BigNumberish;
        deadline: BigNumberish;
        v: BigNumberish;
        r: BytesLike;
        s: BytesLike;
      },
      useEthPath: boolean,
      overrides?: Overrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    swapAndRepay(
      collateralAsset: string,
      debtAsset: string,
      collateralAmount: BigNumberish,
      debtRepayAmount: BigNumberish,
      debtRateMode: BigNumberish,
      permitSignature: {
        amount: BigNumberish;
        deadline: BigNumberish;
        v: BigNumberish;
        r: BytesLike;
        s: BytesLike;
      },
      useEthPath: boolean,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "swapAndRepay(address,address,uint256,uint256,uint256,tuple,bool)"(
      collateralAsset: string,
      debtAsset: string,
      collateralAmount: BigNumberish,
      debtRepayAmount: BigNumberish,
      debtRateMode: BigNumberish,
      permitSignature: {
        amount: BigNumberish;
        deadline: BigNumberish;
        v: BigNumberish;
        r: BytesLike;
        s: BytesLike;
      },
      useEthPath: boolean,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;
  };
}
